using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using Wisej.Web;

namespace NewPortal
{
    public class DatabaseCache
    {
        public int PageSize;
        public int TotalCount;
        DataSet CachedDataSet;
        int _lastRowIndex = -1;
        SqlConnection conn;
        private SqlDataAdapter _adapter;
        private DataGridView _grid;
        public DataTable CachedData
        {
            get
            {
                return this.CachedDataSet.Tables[0];
            }
        }
        public DatabaseCache(int pageSize, SqlConnection conn, string sqlStatement, int totalCount, DataGridView grid)
        {
            var cmd = conn.CreateCommand();
            cmd.CommandText = sqlStatement;
            Init(pageSize, conn, cmd, totalCount, grid);
        }
        public DatabaseCache(int pageSize, SqlConnection connt, SqlCommand cmd, int totalCount, DataGridView grid)
        {
            Init(pageSize, conn, cmd, totalCount, grid);
        }

        private void Init(int pageSize, SqlConnection conn, SqlCommand cmd, int totalCount, DataGridView grid)
        {
            this.conn = conn;
            this._grid = grid;
            PageSize = pageSize;

            this.TotalCount = totalCount;

            _adapter = new SqlDataAdapter(cmd);

            LoadPage(0);
        }

        public void LoadPage(int rowIndex)
        {
            int lastRowIndex = rowIndex - (rowIndex % PageSize);
            if (lastRowIndex == _lastRowIndex)
                return;
            _lastRowIndex = lastRowIndex;
            if (CachedDataSet == null)
                CachedDataSet = new DataSet();
            if (CachedDataSet.Tables.Count > 0)
            {
                CachedDataSet.Tables[0].Rows.Clear();
            }

            _adapter.Fill(CachedDataSet, _lastRowIndex, PageSize, "TableA");
        }
    }

    public class Test
    {
        DatabaseCache _cache;
        DataGridView dataGridView1;
        public void Load()
        {
            SqlConnection conn = new SqlConnection();
            var cmd = conn.CreateCommand();
            cmd.CommandText = "SELECT count(*) FROM Table";
            var totalItems = (int)cmd.ExecuteScalar();
            cmd.CommandText = "SELECT * FROM Table";


            _cache = new DatabaseCache(100, conn, cmd, totalItems, this.dataGridView1);
            this.dataGridView1.CellValueNeeded += dataGridView1_CellValueNeeded;
            this.dataGridView1.RowCount = _cache.TotalCount;
        }


        private void dataGridView1_CellValueNeeded(object sender, DataGridViewCellValueEventArgs e)
        {

            _cache.LoadPage(e.RowIndex);

            int rowIndex = e.RowIndex % _cache.PageSize;

            var col = dataGridView1.Columns[e.ColumnIndex];

            if (_cache.CachedData.Columns.Count - 1 < e.ColumnIndex)
            {
                return;
            }
            e.Value = _cache.CachedData.Rows[rowIndex][e.ColumnIndex];
        }

    }

}